
(define (make-regexp s)
  ((begin string->regexp (lambda (x) x))
   (let make-regexp ([s s])
     (let ([fix-string
	    (lambda (s)
	      (list->string
	       (let loop ([l (string->list s)])
		 (if (null? l)
		     '()
		     (let ([rest (loop (cdr l))]
			   [a (car l)])
		       (case a
			 [(#\( #\) #\. #\* #\? #\+ #\[ #\] #\| #\^ #\$)
			  (list* #\\ a rest)]
			 [else
			  (cons a rest)]))))))]
	   [paren
	    (lambda (s)
	      (if (= 1 (string-length s))
		  s
		  (string-append "(" s ")")))])
       (cond
	[(eq? s 'any) "."]
	[(string? s) (fix-string s)]
	[(pair? s)
	 (let* ([first (car s)]
		[rest (cdr s)]
		[multi
		 (lambda (op)
		   (string-append
		    (paren (apply string-append (map make-regexp rest)))
		    op))])
	   (let loop ([r rest])
	     (if (pair? r)
		 (loop (cdr r))
		 (unless (null? r)
			 (error 'make-regexp "not a proper list"))))
	   (if (null? rest)
	       (error 'make-regexp "no arguments to ~s" first))
	   (case first
	     [* (multi "*")]
	     [? (multi "?")]
	     [+ (multi "+")]
	     [| (apply string-append
		       (list*
			(paren (make-regexp (car rest)))
			(map 
			 (lambda (s)
			   (let ([s (make-regexp s)])
			     (string-append "|" (paren s))))
			 (cdr rest))))]
	     [start (apply string-append "^" (map make-regexp rest))]
	     [end (apply string-append (append (map make-regexp rest) 
					       '("$")))]
	     [all (apply string-append (append `("^")
					       (map make-regexp rest) 
					       '("$")))]
	     [else
	      (error 'make-regexp "bad command ~s" first)]))]
	[else
	 (error 'make-regexp "bad syntax")])))))

  