; Dialog box for picking a tag.

(define tag-dialog%
  (make-class wx:dialog-box%
    (inherit show  new-line  fit)
    (private
      result
      list-box)
    (public 
      [get-answer
       (lambda ()
	 result)]
      [do-ok
       (lambda (button event)
	 (set! result (send list-box get-string-selection))
	 (if (not (null? result))(show  #f)))]
      [do-cancel 
       (lambda (button event)
	 (set! result #f)
	 (show  #f))]
      [do-other
       (lambda (button event)
	 (let ([tag-str (wx:get-text-from-user "Enter the tag name:" "Tag Name"
					       "" this)])
	   (unless (null? tag-str)
	     (set! result tag-str)
	     (show  #f))))])
    (lambda (tags-list)
      (super-init () "Tag Name" #t)
      (make-object wx:message% this "Select a tag name:")
      (new-line )
      (set! list-box
	    (make-object wx:list-box% this () "" wx:const-single 
			 -1 -1 -1 -1 tags-list))
      (new-line )
      (make-object wx:button% this do-ok "OK")
      (make-object wx:button% this do-cancel "Cancel")
      (make-object wx:button% this do-other "Other")
      (fit)
      (show  #t))))

(define get-current-tags
  (lambda (directory filename)
    (let ([temp-edit (make-object mred:hyper-edit% ())])
      (if (send temp-edit load-file  
		(if (string=? dir-separator
			      (string (car (string->list filename))))
		    filename
		    (string-append directory dir-separator filename)))
	  (reverse (map mred:hypertag-name (ivar temp-edit hypertags-list)))
	  (list "top")))))
