;;Dan Grossman
;;6/30/95
;; THIS IS THE CURRENT VERSION OF mred:scheme-mode%
; 
; implements a scheme-mode for Mr. Ed.
; Essentially what happens when you tab or as an option hit return.

(define mred:std-scheme-mode% 
  (make-class 
   mred:std-mode%
   (inherit keymap)
   (class
    [define-list '("define" "defmacro")]
    [lambda-list '("lambda" "let" "let*" "letrec" "recur" "let-values"
		   "let/cc" "let/ec" "letcc" "catch"
		   "let-struct"
		   "case" "when" "unless" "match"
		   "let-enumerate"
		   "make-class" "package"
		   "do" "opt-lambda"
		   "local"
                   "call-with-input-file" "with-input-from-file"
                   "with-input-from-port" "call-with-output-file"
                   "with-output-to-file" "with-output-to-port")]
    [begin-list  '("cond" "begin" "begin0" "delay"
		   "public" "private" "class" "inherit")])	
   (private
    [paren-cache (make-object mred:match-cache%)])
; not used because match-cache% actually does same thing for adjust and
; invalidate so why do all this work to distinguish the two.
;    [has-interesting?
;     (lambda (edit start size)
;       (let ([end (+ start size)])
;	 (cond [(< -1 (send edit find-string ")" 1 start end)) #t]
;	       [(< -1 (send edit find-string "]" 1 start end)) #t]
;	       [(< -1 (send edit find-string "(" 1 start end)) #t]
;	       [(< -1 (send edit find-string "[" 1 start end)) #t]
;	       [(< -1 (send edit find-string "\"" 1 start end)) #t]
;	       [else #f])))])
   (public
    [after-insert
     (lambda (edit start size)
;       (if (has-interesting? edit start size)
       (send paren-cache invalidate start)
;	   (send paren-cache adjust start size))
       #t)]
    [on-delete
     (lambda (edit start size)
;       (if (has-interesting? edit start size)
       (send paren-cache invalidate start)
;	   (send paren-cache adjust start (- 0 size)))
       #t)]
    [get-limit
     (lambda (edit)
       0)]
    [on-char
     ;paren balancing
     (lambda (edit key)
       (let ([limit (get-limit edit)])
	 (if (not (send keymap handle-key-event edit key))
	     (begin
	       ((ivar super on-char) edit key)
	       (let ([code (send key get-key-code)])
		 ; close paren is ASCII 41
		 ; close square bracket is 93
		 ; quote is 34
		 (if (or (= 41 code)
			 (= 34 code)
			 (= 93 code))
		     (let ([here (send edit get-start-position)])
		       (send edit insert (integer->char code))
		       (let ([pos (mred:scheme-backward-match 
				   edit (add1 here) limit paren-cache)])
			 (if (and pos
				  (or (not (= 34 code))
				      (> 5 (abs (- (send edit position-line here)
						   (send edit position-line pos))))))
			     (if (not (= (add1 here) pos))
				 (send edit flash-on pos (add1 pos)))
			     (if (and (= 41 code) match-round-to-square)
				 (begin
				   (send* edit 
					  (begin-edit-sequence)
					  (delete here (add1 here))
					  (insert #\] ));ensure right selection
				   (let ([round-pos (mred:scheme-backward-match
						     edit (add1 here)
						     limit paren-cache)])
				     (if round-pos
					 (send* edit (end-edit-sequence)
						(flash-on round-pos
							   (add1 round-pos)))
					 (begin
					   (send*  edit
						   (delete here (add1 here))
						   (insert #\) ) 
						   (end-edit-sequence))
					   (wx:bell)))))
				 (if (not (= 34 code))(wx:bell)))))
		       #t)
		     #f))) 	
	     #t)))]
    [tabify-on-return  #t]
    [set-tab-on-return
     (lambda (val)
       (set! tabify-on-return val))]
    [match-round-to-square #t]
    [set-match-round-to-square
     (lambda (val)
       (set! match-round-to-square val))]
    [tabify    
     (lambda (edit pos)
       (let* ([last-pos (send edit last-position)]
	      [line (send edit position-line pos)]
	      [okay (> line 0)]
	      [end (if okay (send edit line-start-position line) 0)]
	      [limit (get-limit edit)]
	      [contains (if okay
			    (begin
			      (send paren-cache invalidate end)
			      (mred:scheme-backward-containing-sexp 
			       edit end limit paren-cache))
			    #f)]
	      [contain-line (if contains (send edit position-line contains))]
	      [last (if contains 
			(mred:scheme-backward-match edit end limit paren-cache) 
			#f)]
	      [last-line (if last(send edit position-line last))])
	 (letrec	
	     ([find-offset
	       (lambda (edit pos)
		 (let loop ([p pos][o 0])
		   (let ([c (send edit get-character p)])
		     (cond
		      [(char=? c #\tab)
		       (loop (add1 p) (+ o (- 8 (modulo o 8))))]
		      [(char=? c #\newline)
		       (cons o p)]
		      [(char-whitespace? c)
		       (loop (add1 p) (add1 o))]
		      [else
		       (cons o p)]))))]
	      [visual-offset
	       (lambda (edit pos)
		 (let loop ([p (sub1 pos)])
		   (let ([c (send edit get-character p)])
		     (cond
		      [(= p -1) 0]
		      [(char=? c #\null) 0]
		      [(char=? c #\tab)
		       (let ([o (loop (sub1 p))])
			 (+ o (- 8 (modulo o 8))))]
		      [(char=? c #\newline) 0]
		      [else (add1 (loop (sub1 p)))]))))]
	      [do-indent
	       (lambda (amt)
		 (let*([pos-start end]
		       [curr-offset (find-offset edit pos-start)])
		   (if (not (= amt (car curr-offset)))
		       (begin
			 (send edit delete pos-start (cdr curr-offset))
			 (send edit insert
			       (string-append
				(make-string (quotient amt tab-size) #\tab)
				(make-string (remainder amt tab-size)
					     #\space))
			       pos-start)))))]
	      [id-walker
	       (lambda (str-list)
		 (if (null? str-list) 0
		     (let ([current (car str-list)])
		       (if (or (char-alphabetic? current)
			       (char-numeric? current))
			   (add1 (id-walker (cdr str-list)))
			   (case current
			     ((#\+ #\- #\. #\* #\/ #\< #\= #\> #\! #\? #\:
			       #\$ #\% #\_ #\& #\~ #\^)
			      (add1 (id-walker (cdr str-list))))
			     (else 0))))))]
	      [get-proc
	       (lambda ()
		 (let* ([text (send edit get-text contains
				  (send edit line-end-position contain-line))])
		   (substring text 0 (id-walker (string->list text)))))]
	      [procedure-indent
	       (lambda ()
		 (let* ([proc-name (get-proc)]
			[same? (lambda (str)(string=? str proc-name))])
		   (cond [(ormap same? define-list) 1]
			 [(ormap same? begin-list)  1]
			 [(ormap same? lambda-list) 3]
			 [else 0])))]
	      [special-check
	       (lambda ()
		 (let* ([proc-name (get-proc)]
			[same? (lambda (str)(string=? str proc-name))])
		   (or (ormap same? define-list)
		       (ormap same? lambda-list))))]
	      [indent-first-arg
	       (lambda (start)
		 (car (find-offset edit start)))])
	   (if (and okay
		    (not (char=? (send edit get-character (sub1 end))
				 #\newline)))
	       (send edit insert (string #\newline) 
		     (send edit line-start-position line)))
	   (cond   
	    [(let ([real-start (cdr (find-offset edit end))]) 
	       (if
		(and(<= (+ 3 real-start) (send edit last-position))
		    (string=? ";;;"
			      (send edit get-text real-start(+ 3 real-start))))
		real-start
		#f))
	     => (lambda (x) (send edit set-position x))]
	    [(= line 0)(do-indent 0)]
	    [(or (not contains)(= contains -1))
	     (do-indent 0)]
	    [(= contains last)
	     (do-indent (+ (visual-offset edit contains)
			   (procedure-indent)))]
	    [(special-check)
	     (do-indent (add1 (visual-offset edit contains)))]
	    [(= contain-line last-line)
	     (let ([name-length 
		    (id-walker (string->list 
				(send edit get-text contains
				      (send edit line-end-position
					    contain-line))))])
	       (do-indent (+ (visual-offset edit contains)
			     name-length
			     (indent-first-arg (+ contains 
						  name-length)))))]
	    [else
	     (do-indent (indent-first-arg 
			 (send edit line-start-position
			       last-line)))]))))]
    [tabify-selection
     (lambda (edit start-pos end-pos)
       (let ([first-line (send edit position-line start-pos)]
	     [end-line (send edit position-line end-pos)])
	 (dynamic-wind
	  (lambda () 
	    (if (< first-line end-line)
		(wx:begin-busy-cursor))
	    (send edit begin-edit-sequence))
	  (lambda ()
	    (do ([line first-line (add1 line)])
		((> line end-line))
	      (tabify edit (send edit line-start-position line)))
	    (if (and (>= (send edit position-line start-pos) end-line)
		     (<= (eat-white edit (send edit get-start-position) -1)
			 (send edit line-start-position first-line)))
		(send edit set-position 
		      (let loop ([new-pos (send edit get-start-position)])
			(if (let ([next (send edit get-character new-pos)])
			      (and (char-whitespace? next)
				   (not (char=? next #\newline))))
			    (loop (add1 new-pos))
			    new-pos)))))
	  (lambda ()
	    (send edit end-edit-sequence)(wx:end-busy-cursor)))))]
    [tabify-all
     (lambda (edit)
       (tabify-selection edit 0 (send edit last-position)))]
    [comment-out-selection
     (lambda (edit start-pos end-pos)
       (send edit begin-edit-sequence)
       (let* ([first-line (send edit position-line start-pos)]
	      [last-line (send edit position-line end-pos)])
	 (let line-loop ([curr-line first-line])
	   (if (<= curr-line last-line)
	       (let ([first-on-line (send edit line-start-position curr-line)])
		 (if (not
		      (char=? #\; (send edit get-character first-on-line)))
		     (send edit insert ";" first-on-line))
		 (line-loop (add1 curr-line))))))
       (send edit end-edit-sequence)
       #t)]
    [uncomment-selection
     (lambda (edit start-pos end-pos)
       (send edit begin-edit-sequence)
       (let* ([first-line (send edit position-line start-pos)]
	      [last-line (send edit position-line end-pos)])
	 (let line-loop ([curr-line first-line])
	   (if (<= curr-line last-line)
	       (let ([first-on-line 
		      (eat-white edit (send edit line-start-position curr-line)
				 1)])
		 (send edit delete first-on-line
		       (+ first-on-line
			  (let char-loop ([n 0])
			    (if (char=? #\; 
					(send edit get-character 
					      (+  n first-on-line)))
				(char-loop (add1 n))
				n))))
		 (line-loop (add1 curr-line))))))
       (send edit end-edit-sequence)
       #t)]
    [remove-sexp
     (lambda (edit start-pos)
       (let ([end-pos (mred:scheme-forward-match edit start-pos
						 (send edit last-position))])
	 (if end-pos (send edit kill 0 start-pos end-pos)(wx:bell))
	 #t))]
    [forward-sexp
     (lambda (edit start-pos)
       (let ([end-pos (mred:scheme-forward-match edit start-pos
						 (send edit last-position))])
	 (if end-pos (send edit set-position end-pos)(wx:bell)) 
	 #t))]
    [select-forward-sexp
     (lambda (edit start-pos)
       (let ([end-pos (mred:scheme-forward-match edit start-pos
						 (send edit last-position))])
	 (if end-pos 
	     (send edit set-position start-pos end-pos)
	     (wx:bell)) 
	 #t))]
    [backward-sexp
     (lambda (edit start-pos move?)
       (let ([end-pos (mred:scheme-backward-match edit start-pos (get-limit edit) 
						   paren-cache)])
	 (if end-pos (if move? 
			 (send edit set-position end-pos) 
			 (send edit flash-on end-pos (add1 end-pos)))
	     (wx:bell))
	     #t))]
    [remove-parens-forward
     (lambda (edit start-pos)
       (let* ([pos (eat-white edit start-pos 1)]
	      [first-char (send edit get-character pos)]
	      [paren? (or (char=? first-char #\( )
			  (char=? first-char #\[ ))]
	      [closer (if paren? 
			  (mred:scheme-forward-match 
			   edit pos (send edit last-position)))])
	 (if (and paren? closer)
	     (send* edit (begin-edit-sequence)
		    (delete pos (add1 pos))
		    (delete (-  closer 2) (- closer 1))
		    (end-edit-sequence))
	     (wx:bell))
	 #t))]
    [standard-style-delta
     (send (make-object wx:style-delta%
			wx:const-change-normal)
	   set-delta
	   wx:const-change-family
	   wx:const-modern)]
    [file-format wx:const-media-ff-text]
    [install
     (lambda (edit)
       (send edit set-tabs '() 8 #f)
       (set! tab-size 8)
       ((ivar super install) edit))]
    [evaluate-region
     (lambda (edit start end)
       (let* ([file (send edit get-text start end)]
	      [v (eval-string file)])
	 (when v
	       (display v)
	       (newline)))
       #t)]
    tab-size)  
   (lambda ()
     (super-init)
     (send keymap add-key-function "tabify-at-caret"
	   (lambda (edit event)
	     (tabify-selection edit (send edit get-start-position)
			       (send edit get-end-position))))
     (send keymap add-key-function "do-return"
	   (lambda (edit event)
	     (if tabify-on-return
		 (begin 
		   (send edit begin-edit-sequence)
		   (send edit insert mred:newline-string)
		   (tabify edit (send edit get-start-position))
		   (send edit set-position 
			 (let loop ([new-pos (send edit get-start-position)])
			   (if (let ([next (send edit get-character new-pos)])
				 (and (char-whitespace? next)
				      (not (char=? next #\newline))))
			       (loop (add1 new-pos))
			       new-pos)))
		   (send edit end-edit-sequence))
		 (send edit insert mred:newline-string))))
     (send keymap add-key-function "comment-out"
	   (lambda (edit event)
	     (comment-out-selection edit (send edit get-start-position)
				    (send edit get-end-position))))
     (send keymap add-key-function "un-comment"
	   (lambda (edit event)
	     (uncomment-selection edit (send edit get-start-position)
				   (send edit get-end-position))))
     (send keymap add-key-function "remove-sexp"
	   (lambda (edit event)
	     (remove-sexp edit (send edit get-start-position))))
     (send keymap add-key-function "forward-sexp"
	   (lambda (edit event)
	     (forward-sexp edit (send edit get-start-position))))
     (send keymap add-key-function "move-backward-sexp"
	   (lambda (edit event)
	     (backward-sexp edit (send edit get-start-position) #t)))
     (send keymap add-key-function "flash-backward-sexp"
	   (lambda (edit event)
	     (backward-sexp edit (send edit get-start-position) #f)))
     (send keymap add-key-function "remove-parens-forward"
	   (lambda (edit event)
	     (remove-parens-forward edit (send edit get-start-position))))
     (send keymap add-key-function "select-forward-sexp"
	   (lambda (edit event)
	     (select-forward-sexp edit (send edit get-start-position))))
     (send keymap add-key-function "evaluate-buffer"
	   (lambda (edit event)
	     (evaluate-region edit 0 (send edit last-position))))
     (send keymap add-key-function "evaluate-region"
	   (lambda (edit event)
	     (evaluate-region edit (send edit get-start-position)
			      (send edit get-end-position))))
     (send keymap map-function "TAB" "tabify-at-caret")
     (send keymap map-function "return" "do-return")
     (send keymap map-function "c:c;c:r" "evaluate-region")
     (let ([map-meta
	    (lambda (key func)
	      (for-each (lambda (key)
			  (send keymap map-function key func))
			(mred:meta-prefix-list key)))])
       (map-meta "c:semicolon" "comment-out")
       (map-meta "c:u" "un-comment")
       (map-meta "c:k" "remove-sexp")
       (map-meta "c:f" "forward-sexp")
       (map-meta "c:b" "move-backward-sexp")
       (map-meta "c:p" "flash-backward-sexp")
       (map-meta "c:space" "select-forward-sexp")
       (map-meta "c:l" "evaluate-buffer"))
     (send keymap map-function "c:c;c:b" "remove-parens-forward"))))

(constant mred:std-scheme-mode%)

(define mred:scheme-mode% mred:std-scheme-mode%)

(mred:insert-mode-handler "Scheme" '("ss" "scm" "sch" "mredrc")
                           (lambda args
                             (make-object mred:scheme-mode%)))

(define mred:scheme-interaction-mode%
  (make-class mred:std-scheme-mode%
    (public [get-limit
	     (lambda (edit)
	       (send edit find-prompt))])))

(mred:insert-mode-handler "Scheme Interpreter" ()
			   (lambda args
			     (make-object mred:scheme-interaction-mode%)))
