
#include "wx_stdev.h"

@INCLUDE wxs.xci

@HEADER

@CLASSBASE wxEvent "wx:event":"wx:object"

@CREATOR ()

// These are not ready to be used:
@ H "write-event" : bool WriteEvent(ostream%);
@ H "read-event" : bool ReadEvent(istream%);

@IVAR "event-class" : long eventClass
@IVAR "event-type" : long eventType
@IVAR "event-object" : wxObject! eventObject

// Don't know where else to put these:
@CONSTANT "wx:const-event-type-scroll-top" : int wxEVENT_TYPE_SCROLL_TOP
@CONSTANT "wx:const-event-type-scroll-bottom" : int wxEVENT_TYPE_SCROLL_BOTTOM
@CONSTANT "wx:const-event-type-scroll-lineup" : int wxEVENT_TYPE_SCROLL_LINEUP
@CONSTANT "wx:const-event-type-scroll-linedown" : int wxEVENT_TYPE_SCROLL_LINEDOWN
@CONSTANT "wx:const-event-type-scroll-pageup" : int wxEVENT_TYPE_SCROLL_PAGEUP
@CONSTANT "wx:const-event-type-scroll-pagedown" : int wxEVENT_TYPE_SCROLL_PAGEDOWN
@CONSTANT "wx:const-event-type-scroll-thumbtrack" : int wxEVENT_TYPE_SCROLL_THUMBTRACK

@END


@CLASSBASE wxCommandEvent "wx:command-event":"wx:event"

@CREATOR (int)

@ "get-selection" : int GetSelection();
@ "get-string" : string GetString();
@ "checked?" : bool Checked();
@ "is-selection?" : bool IsSelection();

@IVAR "extra-long" : long extraLong
@IVAR "command-int" : int commandInt
@IVAR "command-string" : string commandString

@CONSTANT "wx:const-event-type-button-command" : int wxEVENT_TYPE_BUTTON_COMMAND
@CONSTANT "wx:const-event-type-checkbox-command" : int wxEVENT_TYPE_CHECKBOX_COMMAND
@CONSTANT "wx:const-event-type-choice-command" : int wxEVENT_TYPE_CHOICE_COMMAND
@CONSTANT "wx:const-event-type-listbox-command" : int wxEVENT_TYPE_LISTBOX_COMMAND
@CONSTANT "wx:const-event-type-text-command" : int wxEVENT_TYPE_TEXT_COMMAND
@CONSTANT "wx:const-event-type-multitext-command" : int wxEVENT_TYPE_MULTITEXT_COMMAND
@CONSTANT "wx:const-event-type-menu-command" : int wxEVENT_TYPE_MENU_COMMAND
@CONSTANT "wx:const-event-type-slider-command" : int wxEVENT_TYPE_SLIDER_COMMAND
@CONSTANT "wx:const-event-type-radiobox-command" : int wxEVENT_TYPE_RADIOBOX_COMMAND
@CONSTANT "wx:const-event-type-text-enter-command" : int wxEVENT_TYPE_TEXT_ENTER_COMMAND
@CONSTANT "wx:const-event-type-set-focus" : int wxEVENT_TYPE_SET_FOCUS
@CONSTANT "wx:const-event-type-kill-focus" : int wxEVENT_TYPE_KILL_FOCUS
@CONSTANT "wx:const-event-type-scrollbar-command" : int wxEVENT_TYPE_SCROLLBAR_COMMAND
@CONSTANT "wx:const-event-type-virt-listbox-command" : int wxEVENT_TYPE_VIRT_LISTBOX_COMMAND

@END


@CLASSBASE wxKeyEvent "wx:key-event":"wx:event"

@CREATOR (int);

@ "control-down?" : bool ControlDown();
@ "shift-down?" : bool ShiftDown();
@ "key-code" : long KeyCode();
@ "position" : void Position(float*,float*);

@IVAR "key-code" : long keyCode
@IVAR "shift-down" : bool shiftDown
@IVAR "control-down" : bool controlDown
@IVAR "meta-down" : bool metaDown
@IVAR "alt-down" : bool altDown
@IVAR "time-stamp" : long timeStamp

@CONSTANT "wx:const-event-type-char" : int wxEVENT_TYPE_CHAR

@END


@CLASSBASE wxMouseEvent "wx:mouse-event":"wx:event"

@CREATOR (int);

@ "button?" : bool Button(int);
@ "button-d-click?" : bool ButtonDClick(int=-1);
@ "button-down?" : bool ButtonDown(int=-1);
@ "button-up?" : bool ButtonUp(int=-1);
@ "control-down?" : bool ControlDown();
@ "shift-down?" : bool ShiftDown();
@ "dragging?" : bool Dragging();
@ "entering?" : bool Entering();
@ "is-button?" : bool IsButton();
@ "left-down?" : bool LeftDown();
@ "left-is-down?" : bool LeftIsDown();
@ "left-up?" : bool LeftUp();
@ "middle-down?" : bool MiddleDown();
@ "middle-is-down?" : bool MiddleIsDown();
@ "middle-up?" : bool MiddleUp();
@ "moving?" : bool Moving();
@ "right-down?" : bool RightDown();
@ "right-is-down?" : bool RightIsDown();
@ "right-up?" : bool RightUp();
@ "shift-down?" : bool ShiftDown();
@ "position" : void Position(float*,float*);

@IVAR "left-down" : bool leftDown
@IVAR "middle-down" : bool middleDown
@IVAR "right-down" : bool rightDown
@IVAR "shift-down" : bool shiftDown
@IVAR "control-down" : bool controlDown
@IVAR "meta-down" : bool metaDown
@IVAR "alt-down" : bool altDown
@IVAR "x" : float x
@IVAR "y" : float y
@IVAR "time-stamp" : long timeStamp

@CONSTANT "wx:const-event-type-left-down" : int wxEVENT_TYPE_LEFT_DOWN
@CONSTANT "wx:const-event-type-left-up" : int wxEVENT_TYPE_LEFT_UP
@CONSTANT "wx:const-event-type-middle-down" : int wxEVENT_TYPE_MIDDLE_DOWN
@CONSTANT "wx:const-event-type-middle-up" : int wxEVENT_TYPE_MIDDLE_UP
@CONSTANT "wx:const-event-type-right-down" : int wxEVENT_TYPE_RIGHT_DOWN
@CONSTANT "wx:const-event-type-right-up" : int wxEVENT_TYPE_RIGHT_UP
@CONSTANT "wx:const-event-type-motion" : int wxEVENT_TYPE_MOTION
@CONSTANT "wx:const-event-type-enter-window" : int wxEVENT_TYPE_ENTER_WINDOW
@CONSTANT "wx:const-event-type-leave-window" : int wxEVENT_TYPE_LEAVE_WINDOW
@CONSTANT "wx:const-event-type-left-dclick" : int wxEVENT_TYPE_LEFT_DCLICK
@CONSTANT "wx:const-event-type-middle-dclick" : int wxEVENT_TYPE_MIDDLE_DCLICK
@CONSTANT "wx:const-event-type-right-dclick" : int wxEVENT_TYPE_RIGHT_DCLICK

@END
